<?php declare(strict_types=1);

namespace App\Entity;

use Doctrine\ORM\Mapping as ORM;

trait CpuCacheTrait {
	#[ORM\Column('l1_data_count', type:'integer', nullable: true, options: array(
		'comment' => 'The number of L1 data caches on the package, usually the same as the number of cores'
	))]
	private ?int $L1dCount = null;

	#[ORM\Column('l1_data_size', type: 'integer', nullable: true, options: array(
		'comment' => 'The size of each Level 1 data cache in KB'
	))]
	private ?int $L1dSize = null;

	#[ORM\Column('l1_data_way', type: 'integer', nullable: true)]
	private ?int $L1dWay = null;

	#[ORM\Column('l1_code_count', type:'integer', nullable: true, options: array(
		'comment' => 'The number of L1 instruction caches on the package, usually the same as the number of cores'
	))]
	private ?int $L1cCount = null;

	#[ORM\Column('l1_code_size', type: 'integer', nullable: true, options: array(
		'comment' => 'The size of each Level 1 instruction cache in KB'
	))]
	private ?int $L1cSize = null;

	#[ORM\Column('l1_code_way', type: 'integer', nullable: true)]
	private ?int $L1cWay = null;

	#[ORM\Column('l1_unified_count', type:'integer', nullable: true, options: array(
		'comment' => 'The number of L1 caches on the package, usually the same as the number of cores'
	))]
	private ?int $L1uCount = null;

	#[ORM\Column('l1_unified_size', type: 'integer', nullable: true, options: array(
		'comment' => 'The size of each Level 1 unified cache in KB'
	))]
	private ?int $L1uSize = null;

	#[ORM\Column('l1_unified_way', type: 'integer', nullable: true)]
	private ?int $L1uWay = null;

	#[ORM\Column('l2_count', type: 'integer', options: array(
		'comment' => 'The number of L2 caches on the package, usually the same as the number of cores'
	))]
	private int $L2Count = 1;

	#[ORM\Column('l2_size', type: 'integer', nullable: true, options: array(
		'comment' => 'The size of each Level 2 cache in KB'
	))]
	private ?int $L2Size;

	#[ORM\Column('l2_way', type: 'integer', nullable: true)]
	private ?int $L2Way;

	#[ORM\Column('l3_count', type: 'integer', options: array(
		'comment' => 'The number of L3 caches on the package'
	))]
	private int $L3Count = 0;

	#[ORM\Column('l3_size', type: 'integer', nullable: true, options: array(
		'comment' => 'The size of each Level 3 cache in KB'
	))]
	private ?int $L3Size;

	#[ORM\Column('l3_way', type: 'integer', nullable: true)]
	private ?int $L3Way;
}
