<?php declare(strict_types=1);

namespace App\Enum;

enum CpuArchitectureEnum: string {
	case ARM = 'arm';
	case ARM64 = 'arm64';
	case EIGHT_OH_ONE_EIGHT_SIX = 'Intel 80186';
	case EIGHT_OH_EIGHT_EIGHT = 'Intel 8088';
	case MIPS = 'MIPS';
	case POWER = 'IBM POWER';
	case POWER_PC = 'PowerPC';
	case RISC_V = 'RISC V';
	case SIX_FIVE_OH_TWO = 'MOS 6502';
	case SIXTY_EIGHT_K = 'Motorola 68k';
	case X86 = 'x86';
	case X86_64 = 'x86_64';
	case Z80 = 'Z80';

	public static function getGroups(): array
	{
		return [
			'Common' => [
				self::X86,
				self::X86_64,
				self::ARM,
				self::ARM64,
			],
			'Historical' => [
				self::EIGHT_OH_EIGHT_EIGHT,
				self::EIGHT_OH_ONE_EIGHT_SIX,
				self::SIX_FIVE_OH_TWO,
				self::SIXTY_EIGHT_K,
				self::POWER_PC,
				self::Z80,
			],
			'Others' => [
				self::MIPS,
				self::POWER,
				self::RISC_V,
			],
		];
	}
}
