<?php

namespace App\Form;

use App\Entity\Brand;
use App\Entity\Fpu;
use App\Entity\Socket;
use Doctrine\ORM\EntityRepository;
use Symfony\Bridge\Doctrine\Form\Type\EntityType;
use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\OptionsResolver\OptionsResolver;

class FpuType extends AbstractType
{
	use BrandCategoryTrait;

    public function buildForm(FormBuilderInterface $builder, array $options): void
    {
        $builder
			->add('socket', EntityType::class, [
				'class' => Socket::class,
				'query_builder' => static fn(EntityRepository $e) => $e->createQueryBuilder('s')->orderBy('s.name', 'ASC'),
			])
			->add('brand', EntityType::class, [
				'class' => Brand::class,
				'query_builder' => self::filterBrands('fpu'),
			])
			->add('series')
            ->add('model')
            ->add('clockSpeed')
            ->add('count')
            ->add('notes')
        ;
    }

    public function configureOptions(OptionsResolver $resolver): void
    {
        $resolver->setDefaults([
            'data_class' => Fpu::class,
        ]);
    }
}
