<?php declare(strict_types=1);

namespace App\Form;

use App\Entity\PreviouslyOwnedCamera;
use Symfony\Component\Form\{AbstractType, FormBuilderInterface};
use Symfony\Component\OptionsResolver\Exception\AccessException;

use Symfony\Component\OptionsResolver\OptionsResolver;

class PreviouslyOwnedCameraType extends AbstractType
{
    /**
     * {@inheritDoc}
     */
    public function buildForm(FormBuilderInterface $builder, array $options): void
    {
        $builder->add('brand')
            ->add('mount')
            ->add('model')
            ->add('isDigital')
            ->add('cropFactor')
            ->add('isWorking')
            ->add('notes')
            ->add('serial')
            ->add('formerlyOwned')
            ->add('purchasePrice')
            ->add('batteryType')
            ->add('filmFormat')
            ->add('received')
            ->add('type');
    }

    /**
     * {@inheritDoc}
     *
     * @throws AccessException
     */
    public function configureOptions(OptionsResolver $resolver): void
    {
        $resolver->setDefaults([
            'data_class' => PreviouslyOwnedCamera::class,
        ]);
    }

    /**
     * {@inheritDoc}
     */
    public function getBlockPrefix(): string
    {
        return 'camerabundle_previouslyownedcamera';
    }
}
